# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global pythonver %(python -c "import sys; print sys.version[:3]" 2>/dev/null || echo none)
%{!?python_sitelib: %global python_sitelib %{_prefix}/lib/python%{pythonver}/site-packages}

# TODO:	if packaging the Mandarin theme, may want to split out the PageActions action
#	into a separate package and require it in both packages
#	(providing moin-action-PageActions here as an alternative)

Summary:	A blue theme based on Mandarin, aiming to make Moin prettier
Name:		moin-theme-solenoid
Version:	2009.12.5
Release:	4.%{__distinit}%{__distvers}
Url:		https://launchpad.net/moin-solenoid/
# Old rpm versions can't handle source filenames with spaces
#Source0:	http://launchpad.net/moin-solenoid/trunk/%{version}/+download/Solenoid Theme %{version}.zip
Source0:	moin-theme-solenoid-%{version}.tar.bz2
Source1:	make-solenoid-tarball.sh
License:	GPLv2
Group:		Applications/Internet
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
Requires:	moin >= 1.8.0
Provides:	moin-action-PageActions = 0
%if "%{pythonver}" == "2.3"
Requires:	python-abi = 2.3
%endif
BuildRequires:	python2, symlinks

%description
A blue theme based on Mandarin, aiming to make Moin prettier.

%prep
%setup -q

sed -i -e 's/\r$//' README.txt

cat << EOF > README.rpm
After installing this package, any newly-created wiki instances should
automatically have the solenoid theme available.

To make the solenoid theme available to an existing wiki instance:
 * copy %{_datadir}/moin/data/plugin/theme/solenoid.py*
   to the data/plugin/theme directory of the wiki instance and do:
   chown apache:apache /path/to/wiki/data/plugin/theme/solenoid.py*
 * copy %{_datadir}/moin/data/plugin/action/PageActions.py*
   to the data/plugin/action directory of the wiki instance and do:
   chown apache:apache /path/to/wiki/data/plugin/action/PageActions.py*
EOF

%build
# Generate normal (.pyc) byte-compiled files.
python -c 'import compileall; compileall.compile_dir(".", 1, "/", 1)'
# Generate optimized (.pyo) byte-compiled files.
python -O -c 'import compileall; compileall.compile_dir(".", 1, "/", 1)'

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{_datadir}/moin/htdocs/solenoid/
install -d -m 755 %{buildroot}%{_datadir}/moin/data/plugin/{action,theme}
install -d -m 755 %{buildroot}%{python_sitelib}/MoinMoin/i18n/themes/solenoid
install -p -m 644 PageActions.py* %{buildroot}%{_datadir}/moin/data/plugin/action
install -p -m 644 solenoid.py* %{buildroot}%{_datadir}/moin/data/plugin/theme
cp -rp htdocs/* %{buildroot}%{_datadir}/moin/htdocs/solenoid/
for translation in translations/*.po
do
	target=$(echo $translation | sed -e 's|.*/\([^/]*\)\.po$|\1_custom.Theme.po|')
	install -p -m 644 $translation \
		%{buildroot}%{python_sitelib}/MoinMoin/i18n/themes/solenoid/$target
done

# Add compat symlink for moin 1.9.0
# (can't do it the other way around as it would break updates)
mkdir -p %{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs/
ln -s %{buildroot}%{_datadir}/moin/htdocs/solenoid \
	%{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs/solenoid
symlinks -cs %{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README.rpm README.txt
%{_datadir}/moin/data/plugin/action/PageActions.py*
%{_datadir}/moin/data/plugin/theme/solenoid.py*
%{_datadir}/moin/htdocs/solenoid/
%{python_sitelib}/MoinMoin/i18n/themes/solenoid/
%{python_sitelib}/MoinMoin/web/static/htdocs/solenoid

%changelog
* Thu Oct 13 2011 Paul Howarth <paul@city-fan.org> 2009.12.5-4
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux
- BR: python2 rather than just python

* Wed Jul 28 2010 Paul Howarth <paul@city-fan.org> 2009.12.5-3
- Rebuild for python 2.7 in Rawhide

* Wed May 26 2010 Paul Howarth <paul@city-fan.org> 2009.12.5-2
- Fix dist tag for RHEL-6 Beta

* Mon Dec  7 2009 Paul Howarth <paul@city-fan.org> 2009.12.5-1
- Update to 2009.12.5
- Add compat symlink to static content from
  %%{python_sitelib}/MoinMoin/web/static/htdocs for moin >= 1.9.0
- BR: symlinks
- Rework translation installation script

* Fri Oct 30 2009 Paul Howarth <paul@city-fan.org> 2009.8.18-1
- Initial RPM version
